diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/asignals.s v15.6301-amd64/pop/src/asignals.s
--- pp0/v15.61-amd64/pop/src/asignals.s	2005-03-11 05:30:39.000000000 -0500
+++ v15.6301-amd64/pop/src/asignals.s	2009-12-26 14:02:54.000000000 -0500
@@ -167,6 +167,13 @@
 
 	leaq	8(%rsp), %rax
 	movq	%rax, SAVED_SP
+        pushq   %r8
+        pushq   %r10
+        pushq   %r11
+        pushq   %r12
+        pushq   %r13
+        pushq   %r14
+        pushq   %r15
 
 	;;; Get the system call address in R10 and the argument count in RAX
 
@@ -235,6 +242,13 @@
 	;;; Restore the stack pointer and return
 
 	movq	SAVED_SP, %rax
+        movq    -16(%rax), %r8
+        movq    -24(%rax), %r10
+        movq    -32(%rax), %r11
+        movq    -40(%rax), %r12
+        movq    -48(%rax), %r13
+        movq    -56(%rax), %r14
+        movq    -64(%rax), %r15
 	leaq	-8(%rax), %rsp
 	movq	$0, SAVED_SP		;;; indicates external call over
 	ret
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/ass.p v15.6301-amd64/pop/src/ass.p
--- pp0/v15.61-amd64/pop/src/ass.p	2005-03-11 06:06:51.000000000 -0500
+++ v15.6301-amd64/pop/src/ass.p	2009-12-26 17:40:45.000000000 -0500
@@ -64,7 +64,8 @@
 section $-Sys$-Vm;
 
 lvars
-	_strsize,			;;; size of structure table in bytes
+      _regmask,
+      _strsize, ;;; size of structure table in bytes
 ;
 
 
@@ -110,9 +111,10 @@
 	_MOVZX	= _16:B7 _biset  _NO_REX_W,	;;; move and zero-extend R/M-16 -> Reg32
 	_NOP	= _16:90,
 	_POP	= _16:8F,
+        _POPs   = _16:58,   ;;; short (1-byte) form
 	_PUSH	= _16:FF,
 	_PUSHI	= _16:68,
-	_PUSHs	= _16:50,			;;; short (1-byte) form
+	_PUSHs	= _16:50,	;;; short (1-byte) form
 	_RET	= _16:C3,
 	_SHIFTI = _16:C1,			;;; shift/rotate by imm8 (modified by TTT)
 	_SUB	= _16:29,
@@ -228,6 +230,7 @@
 	;;; (available to the VM)
 
 	;;; The value is a popint register number shifted left 1
+        ;;; plus bit 0 if pop reg
 
 	;;; arg_reg_0, _1, & _2 :
 	;;; for passing arguments to subroutines. _1 & _2 are (currently) used
@@ -243,18 +246,36 @@
 
 	chain_reg	= _pint(_CHAIN_REG) << 1,		;;; EDX
 
+        pop_reg_A     = _pint(_R13) <<1 || 1,
+        pop_reg_B     = _pint(_R14) <<1 || 1,
+        pop_reg_C     = _pint(_R15) <<1 || 1,
+        nonpop_reg_A = _pint(_R8) <<1,
+        nonpop_reg_B = _pint(_R10) <<1,
+        nonpop_reg_C = _pint(_R11) <<1,
+        nonpop_reg_D = _pint(_R12) <<1,
+
 ;
 
 constant
 
 	;;; REGISTER LVARS
-	;;; (there aren't any!)
 
-	asm_pop_registers		= [[]],
-	asm_nonpop_registers	= [[]],
+        asm_pop_registers = [[]],
+
+        asm_nonpop_registers = [[]],
+
+/*
+
+        asm_pop_registers = [%[], ident pop_reg_A, ident pop_reg_B,
+                                  ident pop_reg_C %],
+        asm_nonpop_registers = [%[], ident nonpop_reg_A, ident nonpop_reg_B,
+                                 ident nonpop_reg_C, ident nonpop_reg_D %],
 
+        asm_nonpop_registers = [%[], ident nonpop_reg_A, ident nonpop_reg_D %],
+*/
 ;
 
+
 lvars
 	_USP_offset,	;;; "static offset" for accumulating adjustments to USP
 ;
@@ -285,7 +306,7 @@
 
 define Drop_w(_word);
 	lvars _word;
-        lvars _pword = _word;
+;;;        lvars _pword = _word;
 	unless _asm_pass then
 		;;; only output the data on the last pass
 ;;;                _extern printf('Drop_w(0x%04x)\n', _word);
@@ -300,7 +321,7 @@
 
 define Drop_l(_long);
 	lvars _long;
-        lvars _pword = _long;
+;;;     lvars _pword = _long;
 	unless _asm_pass then
 		;;; only output the data on the last pass
 ;;;                _extern printf('Drop_l(0x%08x)\n', _long);
@@ -373,7 +394,7 @@
 define constant Drop_short( _opcode, _reg ) with_nargs 2;
         lvars _opcode, _reg, _rex = Get_rex_short(_reg);
         _reg _bimask _7 -> _reg;
-        if _opcode /== _PUSHs or _rex /== _REX_W then
+        if _not(_opcode == _PUSHs or _opcode == _POPs) or _rex /== _REX_W then
             Drop_b(_rex);
         endif;
 	Drop_b(_opcode _add _reg);
@@ -390,9 +411,7 @@
             Drop_b(_rex _sub _8);
           endif;
           _opcode _sub _NO_REX_W -> _opcode;
-;;; needed to be fixed for AMD64
-;;;        elseif _opcode /== _LEA and _opcode /== _BR_IND or _rex /== _REX_W then
-		  elseif _opcode /== _BR_IND or _rex /== _REX_W then
+        elseif _opcode /== _BR_IND or _rex /== _REX_W then
           Drop_b(_rex);
         endif;
 enddefine;
@@ -522,25 +541,20 @@
 ;;; 	plant test against immediate value (different format again)
 
 define constant Drop_test_imm(_imm, _mod, _rm, _disp);
-        lvars _imm, _mod, _rm, _disp;
-        if _-2147483648 _slteq _imm and _imm _slteq _2147483647 then
-           Drop_move_imm(_imm, _REG, _R9, false);
-;;;           mishap(0, 'Drop_test_imm: IMMEDIATE TOO BIG FOR 32-BITS');
-           if _mod /== _REG then
-              Drop_std(_MOV_IN, _R10, _mod, _rm, _disp);
-              _R10 -> _rm;
-           endif;
-           Drop_std(_TEST, _rm, _REG, _R9, false);
+    lvars _imm, _mod, _rm, _disp;
+    if _-2147483648 _slteq _imm and _imm _slteq _2147483647 then
+        if _mod == _REG and _rm == _EAX then
+            ;;; short form
+            Drop_b(_REX_W);
+            Drop_b(_TESTIs);
         else
-	    if _mod == _REG and _rm == _EAX then
-		;;; short form
-                Drop_b(_REX_W);
-		Drop_b(_TESTIs);
-	    else
-		Drop_std(_TESTI, _0, (_mod, _rm, _disp));
-	    endif;
-	    Drop_l(_imm);
+            Drop_std(_TESTI, _0, (_mod, _rm, _disp));
         endif;
+        Drop_l(_imm);
+    else
+        Drop_move_imm(_imm, _REG, _R9, false);
+        Drop_std(_TEST, _R9, _mod, _rm, _disp);
+    endif;
 enddefine;
 
 ;;;	Drop_call_indir:
@@ -1013,7 +1027,7 @@
 		;;; structure is in a stack lvar (from -conskey-)
 		Drop_std(_MOV_IN, _reg, Get_regindir_efa(_SP, _disp));
 	else
-		mishap(0, 'SYSTEM ERROR 1 IN Do_field');
+		mishap(structure, 1, 'SYSTEM ERROR 1 IN Do_field');
 	endif;
 	;;; If it's an external structure, get the real address
 	if exptr then
@@ -1038,7 +1052,7 @@
 			;;; index is in a stack lvar (from -conskey-)
 			Drop_std(_MOV_IN, _ECX, Get_regindir_efa(_SP, _disp));
 		else
-			mishap(0, 'SYSTEM ERROR 2 IN Do_field');
+			mishap(offset, 1, 'SYSTEM ERROR 2 IN Do_field');
 		endif;
 		;;; If updating, load new value from stack to EAX
 		if upd then Drop_std(_MOV_IN, _EAX, Get_upop_efa()) endif;
@@ -1688,13 +1702,24 @@
 /*	Procedure Entry and Exit  */
 
 define I_CREATE_SF();
-	lvars	_offs;
+	lvars	_offs, _num;
 
 	;;; Set the procedure base register.
 	;;; If all is well, the procedure address should be in ARG_REG_0.
 	;;; movl %ARG_REG_0, %PB
 	Drop_std(_MOV, _ARG_REG_0, (_REG, _PB, false));
 
+        ;;; save registers
+        unless _zero(_regmask) then
+            _8 -> _num;
+            until _num == _16 do
+                if _regmask _bitst _shift(_1, _num) then
+                    Drop_short(_PUSHs, _num);
+                endif;
+                _num _add _1 -> _num;
+            enduntil;
+        endunless;
+
 	;;; Save dynamic locals
 	@@PD_TABLE -> _offs;
 	fast_repeat _pint(_Nlocals) times
@@ -1724,7 +1749,7 @@
 
 
 define I_UNWIND_SF();
-	lvars _offs;
+	lvars _offs, _num;
 
 	;;; Remove owner address and on-stack lvars
 	Drop_imm(_ARITHI, _ADDI, @@(w)[_Nstkvars _add _1], (_REG, _SP, false));
@@ -1739,6 +1764,17 @@
 		Drop_std(_POP, _0, _DISP0, _EAX, _0);
 	endrepeat;
 
+        ;;; restore registers
+        unless _zero(_regmask) then
+            _15 -> _num;
+            until _num == _7 do
+                if _regmask _bitst _shift(_1, _num) then
+                    Drop_std(_POP, _0, _REG, _num, false);
+                endif;
+                _num _sub _1 -> _num;
+            enduntil;
+        endunless;
+
 	;;; Restore procedure base register by reaching over return address
 	;;; to get the previous stack-frame owner:
 	;;; movl [4](%SP), %PB
@@ -1871,19 +1907,27 @@
 ;;;		input
 
 define Do_consprocedure(codelist, reg_locals) -> pdr;
-	lvars	codelist, reg_locals, pdr, _code_offset, _size, _reg_spec;
-        lvars _buff, _cnt;
-	dlocal	_asm_drop_ptr, _asm_pass, _strsize;
-
+    lvars codelist, reg_locals, pdr, _code_offset, _size, _reg_spec;
+    lvars reg, _buff, _cnt;
+    dlocal _regmask, _asm_drop_ptr, _asm_pass, _strsize;
 
+/*
 	;;; Check there are no register locals and set _reg_spec to 0
 ;;;        _extern printf('Do_consprocedure, Pass 1\n');
 ;;;        _extern fflush (_0);
 	unless null(reg_locals) then
 		mishap(reg_locals, 1, 'UNEXPECTED REGISTER LOCALS');
 	endunless;
+*/
 	_0 -> _reg_spec;
 
+        ;;; construct reg mask from reg_locals
+        _0 -> _regmask;
+        for reg in reg_locals do
+                _shift(_1, _int(Is_register(reg))) _biset _regmask -> _regmask
+        endfor;
+
+
 	;;; Pass 1 -- calculate instruction offsets
 	_0 ->> _USP_offset -> _strsize;
 	Code_pass(0, codelist) -> _code_offset;
@@ -1929,8 +1973,6 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman and Waldek Hebisch
-		altered Drop_rex to fix exacc
 --- Robert Duncan, Sep 30 1996
 		Added I_IF_TAG for issimple/isinteger tests
 --- Robert John Duncan, Dec 15 1994
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/declare.ph v15.6301-amd64/pop/src/declare.ph
--- pp0/v15.61-amd64/pop/src/declare.ph	2003-11-01 16:15:27.000000000 -0500
+++ v15.6301-amd64/pop/src/declare.ph	2009-12-30 21:24:12.000000000 -0500
@@ -20,7 +20,8 @@
 		;;; system variables
 weak vars
 		_disable, _trap, _system_end, _userlim, _userhi,
-		_call_stack_hi, _call_stack_seg_hi, _plog_save_contn_sp
+		_call_stack_hi, _call_stack_seg_hi, _plog_save_contn_sp,
+                _user_base
 	;
 
 
@@ -40,6 +41,8 @@
 		undef_key, prologvar_key, prologterm_key,
 		intvec_key, shortvec_key, stackmark_key,
 		external_ptr_key, exptr_mem_key,
+                bytevec_key, sbytevec_key, ushortvec_key,
+                uintvec_key, ulongvec_key, longvec_key,
 
 	;
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/fields.p v15.6301-amd64/pop/src/fields.p
--- pp0/v15.61-amd64/pop/src/fields.p	2005-01-06 10:13:58.000000000 -0500
+++ v15.6301-amd64/pop/src/fields.p	2009-12-30 21:15:11.000000000 -0500
@@ -282,7 +282,7 @@
 		round_mult(bitoffs,	bitalign) -> bitoffs
 
 	elseif isinteger(spec) and spec /== 0
-	and #_< -INT_BITS >_# fi_<= spec and spec fi_<= INT_BITS then
+	and #_< -WORD_BITS >_# fi_<= spec and spec fi_<= WORD_BITS then
 		if spec fi_< 0 then 0 fi_- spec else spec endif -> bitsize;
 		t_BIT -> type
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/initial.p v15.6301-amd64/pop/src/initial.p
--- pp0/v15.61-amd64/pop/src/initial.p	2008-06-05 09:49:08.000000000 -0400
+++ v15.6301-amd64/pop/src/initial.p	2010-01-03 07:24:11.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2008. All rights reserved. ----------
+/* --- Copyright University of Sussex 2003. All rights reserved. ----------
  > File:            C.all/src/initial.p
  > Purpose:         Global initialisation
  > Author:          John Gibson (see revisions)
@@ -23,8 +23,7 @@
 	;;; know about new versions. Used as the version number in the string
 	;;; popversion.
 	;;; (See declaration in declare.ph -- in AIX this is a vars.)
-	;;; 156000 -> pop_internal_version;
-	156102 -> pop_internal_version;
+	156301 -> pop_internal_version;
 
 
 	;;; Initialise variables
@@ -86,18 +85,6 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, Feb  4 2008
-		pop_internal_version = 156102
-		Only minor changes, including addition of a simple highlighting
-		extension to ved, and improvements to installation scripts
-	Items copied from 32 bit poplog
-	--- Aaron Sloman, Oct  1 2007
-		pop_internal_version = 156101 (various changes, especially unix_dir.p)
-	--- Aaron Sloman, Apr 11 2007
-		pop_internal_version = 156100 (various changes)
---- Aaron Sloman, Jan 18 2005
-		Chnaged version to
-		pop_internal_version = 156000 (various changes)
 --- Aaron Sloman, 1 Nov 2003
 		Added pop_translate_envvars
 		syfileok will translate environment variables if it is true (default)
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/int_convert.p v15.6301-amd64/pop/src/int_convert.p
--- pp0/v15.61-amd64/pop/src/int_convert.p	2005-03-13 04:53:19.000000000 -0500
+++ v15.6301-amd64/pop/src/int_convert.p	2009-12-24 15:49:43.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2005. All rights reserved. ----------
+/* --- Copyright University of Sussex 1995. All rights reserved. ----------
  > File:            C.all/src/int_convert.p
  > Purpose:
  > Author:          John Gibson, Feb  2 1988 (see revisions)
@@ -15,7 +15,6 @@
 
 	;;; values used for converting between sysints and bigints, etc
 lconstant
-;;;	ICVT_SHIFT			= WORD_BITS-POPINT_BITS+1,
 	ICVT_SHIFT			= WORD_BITS-POPINT_BITS,
 	_ICVT_SHIFT			= _int(ICVT_SHIFT),
 	_ICVT_LOMASK		= _int(2**ICVT_SHIFT-1),
@@ -37,8 +36,9 @@
 	SAVEWORKBGI(_work, _save1, _save2);
 	BGWEAK Bigint_<< (
 		BGWEAK Pint_to_bigint(
-			_pint( _shift(_n, _negate(_ICVT_SHIFT)) _bimask _ICVT_HIMASK ),
-												_work),
+			_pint( _shift(_n, _negate(_ICVT_SHIFT)) 
+                                  _bimask _ICVT_HIMASK),
+			_work),
 		_ICVT_SHIFT) -> res;
 	RESTWORKBGI(_work, _save1, _save2);
 	_n _bimask _ICVT_LOMASK -> _n;
@@ -81,7 +81,8 @@
 	lvars n, _hi, _lo, _rangemask;
 	if isinteger(n) then
                 _int(n) -> _hi;
-		returnif(_nonneg(_hi) and _hi _lteq _rangemask) (_hi)
+		returnif(_nonneg(_hi) and _hi _lteq _rangemask) (_hi);
+
 	elseif iscompound(n) and n!KEY == weakref biginteger_key then
 		n!BGI_SLICES[_0] _bimask _ICVT_LOMASK -> _lo;
 		BGWEAK Bigint_>>(n, _ICVT_SHIFT) -> _hi;
@@ -91,7 +92,7 @@
 				_shift(_hi, _ICVT_SHIFT) _add _lo -> _hi;
 				returnif(_hi _lteq _rangemask) (_hi)
 			endif
-		endif
+		endif;
 	endif;
 	Err(n, _rangemask, false)
 enddefine;
@@ -146,10 +147,6 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, Mar 13 2005
-		Patch for AMD64 poplog provided by Waldek Hebisch
-		ICVT_SHIFT			= WORD_BITS-POPINT_BITS,
-		
 --- John Gibson, Sep 19 1995
 		Used new macros SAVEWORKBGI/RESTWORKBGI to localise use of
 		work_bigint1.
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/intvec.p v15.6301-amd64/pop/src/intvec.p
--- pp0/v15.61-amd64/pop/src/intvec.p	1995-06-03 12:31:03.000000000 -0400
+++ v15.6301-amd64/pop/src/intvec.p	2009-12-30 22:05:52.000000000 -0500
@@ -13,6 +13,19 @@
 
 defclass intvec :int;
 
+defclass untvec :uint;
+
+defclass bytevec :byte;
+
+defclass sbytevec :sbyte;
+
+defclass shortvec :short;
+
+defclass ushortvec :ushort;
+
+defclass longvec :long;
+
+defclass ulongvec :ulong;
 
 /* --- Revision History ---------------------------------------------------
 --- John Gibson, Apr  5 1995
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/lispcore.p v15.6301-amd64/pop/src/lispcore.p
--- pp0/v15.61-amd64/pop/src/lispcore.p	1998-02-12 09:38:38.000000000 -0500
+++ v15.6301-amd64/pop/src/lispcore.p	2009-12-26 21:58:50.000000000 -0500
@@ -1400,7 +1400,7 @@
 enddefine;
 
 
-define lconstant App_package(pkg, procedure pdr, _do_internals);
+define lconstant App_package(pkg, procedure pdr, _do_internals, check_access);
 	lvars _sl, _offs, _lim, entry;
 	stacklength() -> _sl;
 	pkg!PKG_VECTOR -> pkg;
@@ -1409,7 +1409,10 @@
 	while _offs _lt _lim do
 		pkg!(w){_offs} -> entry;
 		while iscompound(entry) do
-			if _do_internals or (entry!KEY == package_external_entry_key) then
+			if (_do_internals or 
+                             (entry!KEY == package_external_entry_key))
+                           and (not(check_access) 
+                                or check_access(entry!PGE_SYM)) then
 				_CHECKUSER;
 				lisp_apply(Return_symbol(entry!PGE_SYM), pdr, 1, 0)
 			endif;
@@ -1421,15 +1424,21 @@
 
 
 define apppackage(pkg, pdr, do_internals, do_inherits);
-	lvars p;
-	Checkr_package(pkg) -> pkg;
-	$-Sys$-Check_procedure(pdr);
-	App_package(pkg, pdr, pop_true(do_internals));
-	if pop_true(do_inherits) then
-		for p in pkg!PKG_USES do
-			App_package(p, pdr, false)
-		endfor
-	endif
+    lvars p;
+    Checkr_package(pkg) -> pkg;
+    $-Sys$-Check_procedure(pdr);
+    App_package(pkg, pdr, pop_true(do_internals), false);
+    if pop_true(do_inherits) then
+        for p in pkg!PKG_USES do
+            App_package(p, pdr, false,
+                 procedure(sym);
+                     lvars entry, name;
+                     sym!SYM_NAME -> name;
+                     Find_pkg_entry(name, pkg, pkg!PKG_USES) -> (entry, , );
+                     entry and (entry!PGE_SYM == sym);
+                 endprocedure)
+        endfor
+    endif
 enddefine;
 
 
@@ -1551,8 +1560,8 @@
 	endif -> (pkgs, do_inherits);
 
 	fast_for pkg in pkgs do
-		apppackage(
 			pkg,
+		apppackage(
 			procedure(sym);
 				if issubstring(string, symbol_string(sym)) then
 					conspair(sym, list) -> list
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/mksyscomp v15.6301-amd64/pop/src/mksyscomp
--- pp0/v15.61-amd64/pop/src/mksyscomp	1993-07-13 11:41:50.000000000 -0400
+++ v15.6301-amd64/pop/src/mksyscomp	2009-12-24 13:00:41.000000000 -0500
@@ -23,7 +23,7 @@
 for IMAGE
 do
 
-corepop11 %nort %noinit << ****
+corepop %nort %noinit << ****
 	lvars savedir = current_directory;
 	'$popsrc/syscomp' -> current_directory;
 	$DEBUG -> pop_debugging;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/newpop v15.6301-amd64/pop/src/newpop
--- pp0/v15.61-amd64/pop/src/newpop	1993-07-09 23:55:48.000000000 -0400
+++ v15.6301-amd64/pop/src/newpop	2008-06-13 05:30:10.000000000 -0400
@@ -15,9 +15,13 @@
 
 # Run the NEWPOP saved image based on corepop
 if [ $# -eq 0 ]; then
-	corepop +$popsys/newpop.psv
+#	echo corepop +$popsys/newpop.psv
+        corepop +$popsys/newpop.psv
+#        gdb /home/hebisch/poplog/v15.61-amd64/pop/pop/corepop
 else
-	corepop +$popsys/newpop.psv "$@"
+#	echo corepop +$popsys/newpop.psv "$@"
+        corepop +$popsys/newpop.psv "$@"
+#        gdb /home/hebisch/poplog/v15.61-amd64/pop/pop/corepop
 fi
 
 # --- Revision History ---------------------------------------------------
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/setpop.p v15.6301-amd64/pop/src/setpop.p
--- pp0/v15.61-amd64/pop/src/setpop.p	2000-01-06 06:58:07.000000000 -0500
+++ v15.6301-amd64/pop/src/setpop.p	2009-12-27 11:03:55.000000000 -0500
@@ -43,6 +43,7 @@
 		Vms_jpi_string, Vms_jpi_int, Vms_get_image_name,
 		Io$-Cons_device, Io$-Get_char, Io$-Rms_parse, Io$-Rms_search,
 		Io$-Cons_stddev, Explode_substring,
+                dummy_procedure_callback_helper,
 		),
 		image_version
 	;
@@ -73,7 +74,8 @@
 				poppid, popusername, popdirectory, popheader,
 				pop_runtime, pop_runtime_actions,
 				pop_first_setpop, pop_nobanner, pop_noinit, popunderx,
-				setpop
+				setpop,
+              dummy_procedure_callback_helper
 			;
 
 constant
@@ -892,6 +894,7 @@
 enddefine;		/* Setup_system */
 
 define lvars Setpop_setup_system();
+        Get_mem_break() -> _user_base;
 	chain(_nextframe(_caller_sp_flush()), _0, Setup_system)
 enddefine;
 
@@ -923,6 +926,11 @@
 	sysexit()
 enddefine;
 
+define dummy_procedure_callback_helper();
+   lvars _dummy1 = 666, _dummy2 = 42;
+   _extern printf('%d, %d\n', _dummy1, _dummy2);
+enddefine;
+
 endsection;		/* $-Sys */
 
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/sys_file_stat.p v15.6301-amd64/pop/src/sys_file_stat.p
--- pp0/v15.61-amd64/pop/src/sys_file_stat.p	2005-03-11 13:56:39.000000000 -0500
+++ v15.6301-amd64/pop/src/sys_file_stat.p	2009-12-24 15:34:16.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2005. All rights reserved. ----------
+/* --- Copyright University of Sussex 1997. All rights reserved. ----------
  > File:            C.unix/src/sys_file_stat.p
  > Purpose:			sys_file_stat	(unix)
  > Author:          John Gibson (see revisions)
@@ -112,8 +112,6 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, Mar 11 2005
-		changes for AMD64 poplog
 --- John Gibson, Mar 20 1999
 		Changes to fix x86 Linux "dev_t" type problem
 --- John Gibson, Mar  8 1997
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/sys_real_time.p v15.6301-amd64/pop/src/sys_real_time.p
--- pp0/v15.61-amd64/pop/src/sys_real_time.p	1995-06-30 12:19:46.000000000 -0400
+++ v15.6301-amd64/pop/src/sys_real_time.p	2009-12-29 23:55:34.000000000 -0500
@@ -14,7 +14,7 @@
 
 ;;; -------------------------------------------------------------------
 
-section $-Sys => sys_real_time;
+section $-Sys => sys_real_time, sys_microtime;
 
 	/*	Time in seconds since midnight 1 Jan 1970 GMT
 	*/
@@ -28,6 +28,16 @@
 #_ENDIF
 enddefine;
 
+define sys_microtime();
+#_IF DEFV BERKELEY >= 4.2
+    lstackmem struct TIMEVAL _tvp;
+    _extern gettimeofday(_tvp, _NULL) -> ;
+    Sint_->_pint(_tvp!TIM_SEC)*1000000 + Sint_->_pint(_tvp!TIM_USEC)
+#_ELSE
+    Sint_->_pint(_extern time(_NULL))*1000000
+#_ENDIF
+enddefine;
+
 endsection;
 
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/syscomp/genproc.p v15.6301-amd64/pop/src/syscomp/genproc.p
--- pp0/v15.61-amd64/pop/src/syscomp/genproc.p	2005-03-11 05:30:40.000000000 -0500
+++ v15.6301-amd64/pop/src/syscomp/genproc.p	2010-01-03 07:29:42.000000000 -0500
@@ -132,6 +132,18 @@
 
 ;;; === REGISTER USAGE ================================================
 
+/*
+   rax - work                rcx - work
+   rdx - chain               rbx - pop user stack
+   rsp - stack               rbp - base
+   rsi - work                rdi - work
+   r8  - non pop lvar        r9  - helper for immediate constants
+   r10 - non pop lvar        r11 - non pop lvar
+   r12 - non pop lvar        r13 - pop lvar
+   r14 - pop lvar            r15 - pop lvar
+
+*/
+
 lconstant
 
 	;;; 80x86 register names and their usage
@@ -194,8 +206,18 @@
 	;;;	Lists of pop/non-pop registers for register locals
 	;;; (none on this machine)
 
-	pop_registers = [[]],
-	nonpop_registers = [[]],
+/*
+        pop_registers = [[] 13 14 15],
+	nonpop_registers = [[] 8 10 11 12],
+
+        pop_registers = [[]],
+
+        nonpop_registers = [[]],
+*/
+        pop_registers = [[]],
+        nonpop_registers = [[] 8 10 11 12],
+/*       nonpop_registers = [[] 8 12], */
+
 ;
 
 ;;; regnumber:
@@ -231,6 +253,39 @@
 	])
 enddefine;
 
+define int_reglabel = newassoc([]); enddefine;
+
+define word_reglabel = newassoc([]); enddefine;
+
+define byte_reglabel = newassoc([]); enddefine;
+
+procedure();
+        lvars n, l, li, lw, lb;
+        for n from 0 to 7 do
+            reglabel(n) -> l;
+            consword(`e`, l(2), l(3), 3) -> li;
+            allbutfirst(1, l) -> lw;
+            if n < 4 then
+                consword(lw(1), `l`, 2)
+            else
+                consword(lw(1), lw(2), `l`, 3)
+            endif -> lb;
+            li ->  int_reglabel(n);
+            lw -> word_reglabel(n);
+            lb -> byte_reglabel(n);
+        endfor;
+        for n from 8 to 15 do
+                consword('r' >< n) -> l;
+                consword('r' >< n >< 'd') -> li;
+                consword('r' >< n >< 'w') -> lw;
+                consword('r' >< n >< 'b') -> lb;
+                n -> regnumber(l);
+                l -> reglabel(n);
+                li -> int_reglabel(n);
+                lw -> word_reglabel(n);
+                lb -> byte_reglabel(n);
+        endfor
+endprocedure();
 
 ;;; Local register operands:
 
@@ -603,7 +658,8 @@
         adjust(opd, INT_OFFS) -> opd;
         if isreg(opd) then
                 ;;; replace with 32-bit register name
-                consword(`e`, opd(2), opd(3), 3) -> opd;
+                int_reglabel(regnumber(opd)) -> opd;
+                ;;; consword(`e`, opd(2), opd(3), 3) -> opd;
 #_IF DEF MASM
         elseif ismem(opd) then
                 consTypedOperand("dword", opd) -> opd;
@@ -617,7 +673,8 @@
 	adjust(opd, SHORT_OFFS) -> opd;
 	if isreg(opd) then
 		;;; replace with 16-bit register name
-		allbutfirst(1, opd) -> opd;
+		;;; allbutfirst(1, opd) -> opd;
+                word_reglabel(regnumber(opd)) -> opd;
 #_IF DEF MASM
 	elseif ismem(opd) then
 		consTypedOperand("word", opd) -> opd;
@@ -630,10 +687,13 @@
 	adjust(opd, BYTE_OFFS) -> opd;
 	if isreg(opd) then
 		;;; replace with 8-bit register name (if allowed)
+/*
 		unless regnumber(opd) < 4 then
 			mishap(opd, 1, 'ILLEGAL 8-BIT REGISTER NAME');
 		endunless;
 		consword(opd(2), `l`, 2) -> opd;
+*/
+                byte_reglabel(regnumber(opd)) -> opd;
 #_IF DEF MASM
 	elseif ismem(opd) then
 		consTypedOperand("byte", opd) -> opd;
@@ -994,7 +1054,7 @@
 define lconstant gen_move_from_l(asm_op);
 	lvars asm_op, (, src, dst) = explode(m_instr);
 	if ismem(src)
-	or isreg(src) and asm_op == asmMOVB and regnumber(src) fi_>= 4
+	;;; or isreg(src) and asm_op == asmMOVB and regnumber(src) fi_>= 4
 	then
 		asmMOVL(src, EAX ->> src);
 	endif;
@@ -1740,7 +1800,9 @@
 
 	dlocal_labs,
 		;;; Names of dynamic local variables
+        regmask,
 	Nstkvars,
+        Nregs,
 		;;; Number of on-stack vars
 ;
 
@@ -1750,17 +1812,32 @@
 
 define M_CREATE_SF();
 	lconstant popint_zero = popint(0);
-	lvars reg_spec_id, Npopstkvars, reg_locals;
+	lvars reg_spec_id, Npopregs, Npopstkvars, reg_locals, n;
 
 	explode(m_instr) -> reg_spec_id -> dlocal_labs -> Npopstkvars
-		-> Nstkvars -> /* Npopregs */ -> reg_locals -> ;
+		-> Nstkvars -> Npopregs -> reg_locals -> ;
 
+/*
 	;;; Check there are no register locals and set the register spec to zero
 	unless null(reg_locals) then
 		mishap(reg_locals, 1, 'UNEXPECTED REGISTER LOCALS');
 	endunless;
+*/
 	0 -> idval(reg_spec_id);
 
+        listlength(reg_locals) -> Nregs;
+
+        ;;; create register mask from reg locals
+        0 -> regmask;
+        fast_for n in reg_locals do regmask || (1 << n) -> regmask endfast_for;
+
+        ;;; Save registers
+        for n from 8 to 15 do
+            if regmask &&/=_0 (1 << n) then
+                asmPUSHL(reglabel(n));
+            endif;
+        endfor;
+
 	;;; Set the procedure base register
 	asmMOVL(immrep(current_pdr_label), PB);
 	;;; Push dynamic locals
@@ -1779,10 +1856,19 @@
 ;;;		plant code to unwind a procedure stack frame
 
 define M_UNWIND_SF();
+        lvars n;
 	;;; Remove owner address and on-stack vars (POP and non-POP)
 	asmADDL((Nstkvars + 1) * 8, SP);
 	;;; Pop dynamic locals
 	applist(rev(dlocal_labs), asmPOPL);
+        ;;; restore registers
+
+        for n from 15 by -1 to 8 do
+            if regmask &&/=_0 (1 << n) then
+                asmPOPL(reglabel(n));
+            endif;
+        endfor;
+
 	;;; Restore procedure base register from previous owner address
 	asmMOVL({^SP 8}, PB);
 enddefine;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/syscomp/m_trans.p v15.6301-amd64/pop/src/syscomp/m_trans.p
--- pp0/v15.61-amd64/pop/src/syscomp/m_trans.p	1998-03-25 09:22:57.000000000 -0500
+++ v15.6301-amd64/pop/src/syscomp/m_trans.p	2009-12-24 15:33:20.000000000 -0500
@@ -2094,7 +2094,7 @@
 	endunless;
 #_ENDIF
 
-	if pd_frame_len > 16:FF then
+	if pd_frame_len > MAX_STACK_FRAME_SIZE then
 		mishap(p, 1, 'PROCEDURE STACK FRAME TOO LARGE (too many lvars)')
 	endif;
 
@@ -2181,8 +2181,19 @@
 				2);
 
 	asm_outshort(reg_spec, 1);				;;; PD_REGMASK
-
-	asm_outbyte(
+#_IF DEF FRAME_LEN_16BIT
+        asm_outshort(0, 1);
+        asm_outshort
+#_ELSE
+#_IF DEF FRAME_LEN_32BIT
+        asm_outshort(0, 1);
+        asm_outint(0, 1);
+        asm_outint
+#_ELSE
+        asm_outbyte
+#_ENDIF
+#_ENDIF
+	(
 			;;; stack frame length in words
 			pd_frame_len,					;;; PD_FRAME_LEN
 			;;; see above
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/syscomp/mcdata.p v15.6301-amd64/pop/src/syscomp/mcdata.p
--- pp0/v15.61-amd64/pop/src/syscomp/mcdata.p	1995-08-24 13:17:32.000000000 -0400
+++ v15.6301-amd64/pop/src/syscomp/mcdata.p	2009-12-24 15:32:59.000000000 -0500
@@ -107,6 +107,15 @@
 endsection;		/* $- */
 
 
+constant macro MAX_STACK_FRAME_SIZE =
+  #_IF DEF FRAME_LEN_16BIT 
+          16:FFFF
+  #_ELSEIF DEF FRAME_LEN_32BIT
+          16:FFFFFFFF
+  #_ELSE
+          16:FF
+  #_ENDIF;
+
 section $-Popas;
 
 constant macro (
